diff --git a/source/lib/canonical.h b/source/lib/canonical.h
index fe7b18e..c621936 100644
--- a/source/lib/canonical.h
+++ b/source/lib/canonical.h
@@ -1,111 +1,111 @@
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str392,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str389,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str258,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str436,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str285,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str222,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str418,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str267,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str361,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str567,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str416,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str512,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str690,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str539,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str689,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str320,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str750,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str302,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str732,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str64,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str811,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str134,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str186,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str324,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str150,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str154,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str130,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str466,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str166,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str170,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str322,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str142,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str332,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str158,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str162,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str138,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str236,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str574,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str580,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str268,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str88,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str140,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str278,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str104,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str108,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str84,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str420,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str120,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str250,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str110,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str54,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str147,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str476,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str463,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str442,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str562,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str813,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str248,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str749,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str591,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str702,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str796,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str680,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str430,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str448,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str311,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str391,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str446,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str312,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str286,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str121,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str176,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str375,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str337,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str282,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str242,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str206,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str211,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str536,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str651,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str683,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str613,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str329,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str426,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str89,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str344,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str479,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str548,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str209,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str661,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str608,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str634,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str610,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str72,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str388,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str153,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str443,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str254,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str281,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str78,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str437,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str210,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str252,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str710,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str692,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str700,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str495,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str243,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str106,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str869,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str425,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str392,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str389,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str258,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str436,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str285,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str222,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str418,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str267,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str361,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str567,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str416,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str512,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str690,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str539,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str689,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str320,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str750,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str302,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str732,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str64,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str811,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str134,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str186,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str324,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str150,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str154,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str130,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str466,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str166,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str170,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str322,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str142,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str332,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str158,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str162,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str138,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str236,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str574,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str580,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str268,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str88,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str140,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str278,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str104,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str108,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str84,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str420,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str120,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str250,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str110,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str54,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str147,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str476,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str463,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str442,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str562,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str813,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str248,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str749,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str591,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str702,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str796,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str680,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str430,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str448,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str311,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str391,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str446,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str312,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str286,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str121,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str176,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str375,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str337,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str282,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str242,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str206,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str211,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str536,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str651,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str683,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str613,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str329,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str426,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str89,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str344,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str479,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str548,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str209,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str661,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str608,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str634,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str610,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str72,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str388,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str153,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str443,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str254,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str281,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str78,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str437,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str210,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str252,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str710,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str692,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str700,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str495,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str243,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str106,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str869,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str425,
diff --git a/source/lib/canonical_dos.h b/source/lib/canonical_dos.h
index aa82651..7eb9b3e 100644
--- a/source/lib/canonical_dos.h
+++ b/source/lib/canonical_dos.h
@@ -1,15 +1,15 @@
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_0,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_4,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_5,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_8,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_12,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_13,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_17,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_21,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_22,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_26,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_31,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_35,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_38,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_42,
-  (int)(long)&((struct stringpool2_t *)0)->stringpool_dos_47,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_0,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_4,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_5,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_8,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_12,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_13,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_17,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_21,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_22,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_26,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_31,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_35,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_38,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_42,
+  (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_dos_47,
diff --git a/source/lib/canonical_local.h b/source/lib/canonical_local.h
index 7018202..f0dec91 100644
--- a/source/lib/canonical_local.h
+++ b/source/lib/canonical_local.h
@@ -1,2 +1,2 @@
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str193,
-  (int)(long)&((struct stringpool_t *)0)->stringpool_str496,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str193,
+  (int)(INT_PTR)&((struct stringpool_t *)0)->stringpool_str496,
diff --git a/source/lib/iconv.c b/source/lib/iconv.c
index b7a04f8..b920820 100644
--- a/source/lib/iconv.c
+++ b/source/lib/iconv.c
@@ -18,6 +18,9 @@
  */
 
 #include <iconv.h>
+#ifndef ICONV_CONST
+# define ICONV_CONST
+#endif
 
 #include <limits.h>
 #include <stdlib.h>
@@ -172,7 +175,7 @@ static const struct stringpool2_t stringpool2_contents = {
 };
 #define stringpool2 ((const char *) &stringpool2_contents)
 static const struct alias sysdep_aliases[] = {
-#define S(tag,name,encoding_index) { (int)(long)&((struct stringpool2_t *)0)->stringpool_##tag, encoding_index },
+#define S(tag,name,encoding_index) { (int)(INT_PTR)&((struct stringpool2_t *)0)->stringpool_##tag, encoding_index },
 #include "aliases2.h"
 #undef S
 };
diff --git a/source/lib/localcharset.h b/source/lib/localcharset.h
new file mode 100644
index 0000000..06e7bc0
--- /dev/null
+++ b/source/lib/localcharset.h
@@ -0,0 +1,48 @@
+/* Determine a canonical name for the current locale's character encoding.
+   Copyright (C) 2000-2003 Free Software Foundation, Inc.
+   This file is part of the GNU CHARSET Library.
+
+   This program is free software; you can redistribute it and/or modify it
+   under the terms of the GNU Library General Public License as published
+   by the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+
+   You should have received a copy of the GNU Library General Public
+   License along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
+   USA.  */
+
+#ifndef _LOCALCHARSET_H
+#define _LOCALCHARSET_H
+
+#if 0 && BUILDING_LIBCHARSET
+#define LIBCHARSET_DLL_EXPORTED __attribute__((__visibility__("default")))
+#else
+#define LIBCHARSET_DLL_EXPORTED
+#endif
+
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+
+/* Determine the current locale's character encoding, and canonicalize it
+   into one of the canonical names listed in config.charset.
+   The result must not be freed; it is statically allocated.
+   If the canonical name cannot be determined, the result is a non-canonical
+   name.  */
+extern LIBCHARSET_DLL_EXPORTED const char * locale_charset (void);
+
+
+#ifdef __cplusplus
+}
+#endif
+
+
+#endif /* _LOCALCHARSET_H */
diff --git a/source/lib/loop_wchar.h b/source/lib/loop_wchar.h
index cc19d83..d5c8f01 100644
--- a/source/lib/loop_wchar.h
+++ b/source/lib/loop_wchar.h
@@ -35,8 +35,10 @@
 # include <time.h>
 # include <wchar.h>
 # define BUF_SIZE 64  /* assume MB_LEN_MAX <= 64 */
+#ifndef _WIN32
   /* Some systems, like BeOS, have multibyte encodings but lack mbstate_t.  */
   extern size_t mbrtowc ();
+#endif
 # ifdef mbstate_t
 #  define mbrtowc(pwc, s, n, ps) (mbrtowc)(pwc, s, n, 0)
 #  define mbsinit(ps) 1
diff --git a/source/lib/relocatable.c b/source/lib/relocatable.c
index 89b6c27..60612c8 100644
--- a/source/lib/relocatable.c
+++ b/source/lib/relocatable.c
@@ -329,7 +329,7 @@ DllMain (HINSTANCE module_handle, DWORD event, LPVOID reserved)
       /* The DLL is being loaded into an application's address range.  */
       static char location[MAX_PATH];
 
-      if (!GetModuleFileName (module_handle, location, sizeof (location)))
+      if (!GetModuleFileNameA (module_handle, location, sizeof (location)))
         /* Shouldn't happen.  */
         return FALSE;
 
@@ -337,7 +337,7 @@ DllMain (HINSTANCE module_handle, DWORD event, LPVOID reserved)
         /* Shouldn't happen.  */
         return FALSE;
 
-      shared_library_fullname = strdup (location);
+      shared_library_fullname = _strdup (location);
     }
 
   return TRUE;
